//木同士の距離を求める。
//g++ -I$LEDAROOT/incl -L$LEDAROOT -L/usr/X11R6/lib -o tree-dis-2 tree-distance-2.cpp -lW -lP -lG -lL -lX11 -lm


#include <LEDA/graphics/graphwin.h>
#include <LEDA/graph/graph.h>
#include <LEDA/graph/templates/shortest_path.h>
#include <LEDA/core/list.h>
#include <LEDA/graph/node_matrix.h>

#define SIZE 56

using namespace leda;
using namespace std;              

int main()
{
  GRAPH<int,double> G,H;
  edge e;
  node v,u;
  int M1[SIZE][SIZE],M2[SIZE][SIZE];
  int sum1=0,sum2=0,i,j,max=0,tmp;
  double sq;
  
  G.read("graph1.gw");
  H.read("graph2.gw");
  G.make_undirected();
  H.make_undirected();
  
  edge_array<int> cost1(G),cost2(H);
  
  forall_edges(e,G)
    cost1[e] = 1;
  
  forall_edges(e,H)
    cost2[e] = 1;
  
  node_array<int> dist1(G,MAXINT);
  node_array<int> dist2(H,MAXINT);
  node_array<edge> pred1(G),pred2(H);
  //node_matrix<int> M1(G),M2(H);
  
  // cout << "[1]" <<endl;
  
  
  
  forall_nodes(v,G){
    DIJKSTRA_T(G,v,cost1,dist1,pred1);
    if(index(v) < SIZE)
      forall_nodes(u,G){
	if(index(u) < SIZE)
	  M1[index(v)][index(u)]  = dist1[u];
      }
  }

  /*
  cout << "graph[1]" <<endl;
  
  forall_nodes(v,G){
    if(index(v) < SIZE){
      cout << index(v) << "|";
      DIJKSTRA_T(G,v,cost1,dist1,pred1);
      forall_nodes(u,G){
	if(index(u) < SIZE)
	  if(index(v)==index(u))
	    printf("0  ");
	  else
	    printf("%d  ",dist1[u]);
      }
    }
    else
      break;
    putchar('\n');
  }
  putchar('\n');
  */

  forall_nodes(u,H){
    DIJKSTRA_T(H,u,cost2,dist2,pred2);
    if(index(u) < SIZE)
      forall_nodes(v,H){
	if(index(v) < SIZE)
	  M2[index(u)][index(v)] = dist2[v];
      }
  }

  /*
  cout << "graph[2]" <<endl;
  
  forall_nodes(v,H){
    if(index(v) < SIZE){
      cout << index(v) << "|";
      DIJKSTRA_T(H,v,cost2,dist2,pred2);
      forall_nodes(u,H){
	if(index(u) < SIZE)
	  if(index(v)==index(u))
	    printf("0  ");
	  else
	    printf("%d  ",dist2[u]);
      }
    }
    else
      break;
    putchar('\n');
  }
  putchar('\n');
  */
  
  for(i=0;i<SIZE;i++){
    for(j=i+1;j<SIZE;j++){
      if(M1[i][j] > M2[i][j]){
	tmp=M1[i][j]-M2[i][j];
	sum1 += tmp;
	sum2 += tmp*tmp;
	if(tmp>max)
	  max=tmp;
      }
      else{
	tmp=M2[i][j]-M1[i][j];
	sum1 += tmp;
	sum2 += tmp*tmp;
	if(tmp>max)
	  max=tmp;
      }
    }
  }
  
  sq = sqrt(sum2);
  
  cout << max << endl;
  cout << sum1 << endl;
  cout << sq << endl;
  
  
  /*  
      for(i=0;i<SIZE;i++){
      for(j=0;j<SIZE;j++){
      cout  << i <<"-" << j <<" " << "distance " << M1[i][j] <<" "<< M2[i][j]<< endl; 
      }
      }
  */
  
  
  
  return 0;
}

